""" goal.py
 Copyright (C) 1998 Aloril
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""

from types import *

class goal:
    def __init__(self,desc="some goal",fulfilled=None,subgoals=[],
                 time=None, debug=0):
        self.__doc__=desc
        if fulfilled: self.fulfilled=fulfilled
        else: self.fulfilled=lambda :0 #false
        self.subgoals=subgoals[:]
        self.time=time
        self.debug=debug
    def check_goal(self, me, time, depth=0):
        #is it right time range?
        if self.time and self.time!=time: return
        if self.debug:
            print "\t"*depth+"GOAL: bef fulfilled:",self.__doc__,self.fulfilled
        if self.fulfilled(me): return
        for sg in self.subgoals:
            if type(sg)==FunctionType or type(sg)==MethodType:
                res=sg(me)
                if self.debug: print "\t"*depth+"GOAL: function:",sg,res
            else:
                if self.debug: print "\t"*depth+"GOAL: bef sg:",sg.__doc__
                res=sg.check_goal(me,time,depth+1)
                if self.debug: print "\t"*depth+"GOAL: aft sg:",sg.__doc__,res
            if res!=None: return res
